from BaseHTTPServer import HTTPServer, BaseHTTPRequestHandler
import urllib
import urllib2
import cgi
import json
import re
import sys
import time
import threading

listlock = threading.Lock()
running = True
try:
    pfile = open('dobroprefs.json', 'r')
    pdata = pfile.read()
    pfile.close()
    threads, timeout, headers = json.loads(pdata)
except:
    threads = {}
    timeout = 60
    headers = {'User-Agent': 'Mozilla/5.0'}
modified = {}
autoadded = {}


def check(tid, count=1, oppost=False, retrycount=3):
    global headers
    if oppost:
        request = urllib2.Request(
            'http://dobrochan.com/api/post/%s.json' % (tid))
    else:
        request = urllib2.Request(
            'http://dobrochan.com/api/thread/%s/last.json?count=%d' % (tid, count))
    request.add_header('Host', 'dobrochan.com')
    for k, v in headers.items():
        request.add_header(k, v)
    opener = urllib2.build_opener()
    done = False
    while not done and retrycount != 0:
        try:
            resource = opener.open(request)
            data = resource.read()
            resource.close()
            done = True
        except urllib2.HTTPError as e:
            if e.code == 503:
                time.sleep(3)
            else:
                return None
            retrycount -= 1
    if not done:
        return None
    try:
        info = json.loads(data)
        if 'code' in info:
            return None
        return info
    except ValueError:
        return None


def normalize(tid, board):
    tid = tid.replace('res/', '')
    if tid[0] == '/':
        tid = tid[1:]
    if tid[0].isdigit():
        tid = board + '/' + tid
    if not tid.startswith(board + '/'):
        return None
    return tid


def nextthread(tid, info):
    global headers
    ref_re = re.compile(
        '>>((?:/?(?:b|u|rf|dt|vg|r|cr|lor|mu|oe|s|w|hr|a|ma|sw|hau|azu|tv|cp|gf|bo|di|vn|ve|wh|fur|to|bg|wn|slow|mad|d|news)/)?[0-9]+)')
    url_re = re.compile(
        '((?:b|u|rf|dt|vg|r|cr|lor|mu|oe|s|w|hr|a|ma|sw|hau|azu|tv|cp|gf|bo|di|vn|ve|wh|fur|to|bg|wn|slow|mad|d|news)/res/[0-9]+)')
    try:
        if info['posts_count'] >= 500:
            n_info = check(tid, info['posts_count'] - 499)
            if n_info:
                for m in n_info['posts']:
                    try:
                        refs = ref_re.findall(m['message'])
                        urls = url_re.findall(m['message'])
                        allrefs = refs + urls
                        for t in allrefs:
                            t = normalize(t, tid.split('/')[0])
                            test = check(t)
                            if test:
                                test = check(t, oppost=True)
                                if test:
                                    try:
                                        nrefs = ref_re.findall(test['message'])
                                        nurls = url_re.findall(test['message'])
                                        allnrefs = nrefs + nurls
                                        for q in allnrefs:
                                            if normalize(q, tid.split('/')[0]) == tid:
                                                return t
                                    except KeyError:
                                        continue
                    except KeyError:
                        continue
    except KeyError:
        pass
    return None


def threadcheck(tid):
    global threads, modified, autoadded, listlock
    info = check(tid)
    if info == None:
        return None
    try:
        if info['posts_count'] >= 500:
            try:
                nt = nextthread(tid, info)
                if nt != None:
                    ninfo = check(nt, oppost=True)
                    listlock.acquire()
                    try:
                        if ninfo and nt not in threads:
                            autoadded[nt] = {'last_modified': ninfo['date'],
                                             'display_id': ninfo['display_id'],
                                             'posts_count': 0,
                                             'title': ninfo['subject']}
                    except KeyError:
                        pass
                    listlock.release()
            except KeyError:
                pass
        listlock.acquire()
        try:
            if info['last_modified'] != threads[tid]['last_modified']:
                modified[tid] = {'last_modified': info['last_modified'],
                                 'display_id': info['posts'][0]['display_id'],
                                 'posts_count': info['posts_count'],
                                 'title': info['title']}
            else:
                threads[tid]['title'] = info['title']
                threads[tid]['posts_count'] = info['posts_count']
        except KeyError:
            pass
        listlock.release()
    except KeyError:
        return None


def threadlink(tid):
    global threads, modified, autoadded, listlock
    listlock.acquire()
    link = None
    try:
        if tid in modified and modified[tid]['last_modified'] != threads[tid]['last_modified']:
            link = u'<b><a href="/go?tid=%s&post=%s" target="_blank">&gt;&gt;%s</a> <a href="/del?tid=%s">X</a> <a href="/read?tid=%s">V</a> - %s - %s - %s</b>' % \
                (urllib.quote(tid), threads[tid]['display_id'],
                    tid, urllib.quote(tid), urllib.quote(
                        tid), modified[tid]['posts_count'],
                    modified[tid]['title'], modified[tid]['last_modified'])
        else:
            link = u'<a href="/go?tid=%s&post=%s" target="_blank">&gt;&gt;%s</a> <a href="/del?tid=%s">X</a> <a href="/read?tid=%s">V</a> - %s - %s - %s' % \
                (urllib.quote(tid), threads[tid]['display_id'],
                    tid, urllib.quote(tid), urllib.quote(
                        tid), threads[tid]['posts_count'],
                    threads[tid]['title'], threads[tid]['last_modified'])
    except KeyError:
        link = None
    listlock.release()
    return link


def threadlinks():
    links = ''
    for k in threads.keys():
        link = threadlink(k)
        if link != None:
            links += link + '<br/>'
    return links


def listing():
    global modified, threads, autoadded
    page = '<body><form method="GET" action="/add"><input name="tid"/><button type="submit">Add</button></form>' + \
        threadlinks() + \
        '<hr/><a href="/shutdown">Shut down</a></body>'
    if len(modified) != 0:
        return '<html><head><title>[%d] updates</title></head>%s</html>' % (len(modified), page)
    else:
        return '<html><head><title>___</title></head>%s</html>' % (page)


def save():
    global threads, timeout, headers, listlock
    pfile = open('dobroprefs.json', 'w')
    listlock.acquire()
    pfile.write(json.dumps((threads, timeout, headers)))
    listlock.release()
    pfile.close()


def checkall():
    global threads, autoadded, listlock
    listlock.acquire()
    if len(autoadded) != 0:
        threads.update(autoadded)
        autoadded = {}
    thr = [i for i in threads.keys()]
    listlock.release()
    for i in thr:
        threadcheck(i)


class CheckingThread(threading.Thread):

    def run(self):
        while running:
            checkall()
            time.sleep(timeout)


class dobroserver(BaseHTTPRequestHandler):

    def do_GET(self):
        global running, threads, timeout, headers, modified
        path, query = urllib.splitquery(self.path)
        if query == None:
            query = ''
        query = cgi.parse_qs(query)
        if path == '/shutdown':
            save()
            running = False
        if path == '/add':
            try:
                tid = urllib.unquote(query['tid'][0])
                info = check(tid)
                if info and tid not in threads:
                    threads[tid] = {'last_modified': info['last_modified'],
                                    'display_id': info['posts'][0]['display_id']}
                save()
            except KeyError:
                pass
        if path == '/del':
            try:
                tid = urllib.unquote(query['tid'][0])
                del threads[tid]
                if tid in modified.keys():
                    del modified[tid]
                save()
            except KeyError:
                pass
        if path == '/read':
            try:
                tid = urllib.unquote(query['tid'][0])
                threads[tid] = modified[tid]
                del modified[tid]
                save()
            except KeyError:
                pass
        self.send_response(200)
        self.send_header("Content-type", "text/html")
        if path == '/go':
            try:
                tid = urllib.unquote(query['tid'][0])
                post = urllib.unquote(query['post'][0])
                self.send_header(
                    "Refresh", "0;url=http://dobrochan.com/%s.xhtml#i%s" % (tid.replace('/', '/res/'), post))
                if tid in modified:
                    threads[tid] = modified[tid]
                    del modified[tid]
                save()
            except KeyError:
                self.send_header("Refresh", str(timeout) + ";url=/")
        else:
            self.send_header("Refresh", str(timeout) + ";url=/")
        self.end_headers()
        if path in ['/', '/del', '/add', '/read']:
            self.wfile.write(listing().encode('cp1251'))
        sys.stdout.flush()
        sys.stderr.flush()

if __name__ == '__main__':
    chk = CheckingThread()
    chk.start()
    sys.stdout = open('stdout.txt', 'w')
    sys.stderr = open('stderr.txt', 'w')
    httpd = HTTPServer(('127.0.0.1', 8000), dobroserver)
    while running:
        httpd.handle_request()
    chk.join()